
from onlinemid.utils.online_data_structures import NpVec
import numpy as np
def make_onlineroi_from_roi_array(roi_array):
    '''
    input is a roi matrix of the shape
    e.g.  (roi_nr x slow scan dim x fast scan dim)
    e.g.  (5, 512, 128)
    e.g.  (5, 1024)
    where each ( x, 512, 128) is True or False, depending on the roi
    
    '''
    num_rois = roi_array.shape[0]
    print(f"num rois {num_rois}")


    def compress_roi_array(roi_array):
        
        compressed_data = NpVec(dtype=np.uint64)
        roi_ravel = roi_array.reshape(-1)
        print("compressing", roi_ravel)
        index = 0
        while index < roi_array.size:
            length = 0

            val = roi_ravel[index]

            if val is True:
                length = 1
                while roi_ravel[index+length] is True:
                    length +=1         

                print("(index, lnegth)", index, length)
                compressed_data.add(np.array([index, length], dtype=np.uint64))
                print(compressed_data.get())
                index += length
            else:
                print("val at ", index, "false")
                index += 1
        print("after compressing", compressed_data.get())
        return compressed_data.get()
            
    online_roi_data = dict()
    for roi_nr in range(num_rois):
        this_roi_array = roi_array[roi_nr]
        
        online_roi_data[f'{roi_nr}'] = compress_roi_array(this_roi_array)

    # reshape this online_roi_data into a np array.
    online_roi_data_max_length = 0
    for key, this_online_roi_data in online_roi_data.items():
        this_size = this_online_roi_data.size
        if this_size > online_roi_data_max_length:
            online_roi_data_max_length = this_size
    
    online_roi = np.zeros(shape=(num_rois, online_roi_data_max_length), dtype=np.uint64)
    for key, this_online_roi_data in online_roi_data.items():
        this_size = this_online_roi_data.size
        online_roi[int(key),:this_size] = this_online_roi_data

    return online_roi 



